// Datei: BarGraph.C
//
// Holger Klabunde 
// 30.04.2001
// Compiler CC5x

#include "prozess.h"      // Der verwendete Prozessor

#include "bargraph.h"
#include "protos.h"

#include "interupt.c"
#include <math16.h>
#include "initpic.c"
#include "delay.c"
#include "lcd.c"

unsigned char ad0; //Puffer fr AD Wandlung
unsigned char ad1; //Puffer fr AD Wandlung
unsigned char refresh; //Anzeige auffrischen

//*******************************************************
// Hauptprogramm
//*******************************************************
void main()
{
 InitPIC(); //Interrupts und so weiter einstellen
 LCDInit(); //LCD-Anzeige initialisieren !!
 CGInit();  //Symbole fr Balken in CG-Ram der LCD-Anzeige
 LCDWrite("Bargraph");
 Delay1ms(250);
 Delay1ms(250);
 Delay1ms(250);
 Delay1ms(250);
 LCDCls();  //Sonst bleibt manchmal Dreck in der Anzeige stehen
 
 //Interrupts erlauben
 GIE=1;
 TMR0=0;        //Zhler auf Null, Interrupt bei bergang 0xFF->0x00
 T0IE=1; //Interrupt bei berlauf TMR0
 
 refresh=0; 
 ad0=0;
 ad1=0;
 
 while(1) // Programm-Endlosschleife
  {

   if(refresh>0) //Nur Anzeige auffrischen wenn der Wert sich ndert
    {
     if(ad0>LED1MAX) lcdport|=ALARM0; //Alarm setzen, Ausgabe bei nchster LCD-Aktion
     else lcdport&=~ALARM0; //Alarm lschen, Ausgabe bei nchster LCD-Aktion
 
     LCDPos(1,1); //Zurck zum Anfang der Anzeige
     ShowLCDLines(ad0); //Balken Anzeigen

     if(GPIO.3) //Zwei Balken Modus aktiv
      {
       if(ad1>LED2MAX) lcdport|=ALARM1; //Alarm setzen, Ausgabe bei nchster LCD-Aktion
       else lcdport&=~ALARM1; //Alarm lschen, Ausgabe bei nchster LCD-Aktion
 
       LCDPos(2,1); //Zurck zum Anfang der Anzeige
       ShowLCDLines(ad1); //Balken Anzeigen
      }
      
     refresh=0;   //stndige LCD Aktivitt vermeiden
    }

  } //while(1) Endlosschleife

}

void ShowLCDLines(unsigned char dat)
{
 unsigned char full,rest,j;

#ifdef LCD1x16
 unsigned char position;
 position = 0;
#endif

 if(dat>LCDMAX) //Anzeige bergelaufen ?
  {
   full=LCDWIDTH;  //Dann Vollausschlag
   rest=0xff;      //Keine Teilstriche am Ende der Anzeige
  }
 else
  {
   full = dat / LCDSCALE; //Anzahl Striche ermitteln
   rest=full%5;       //Teilstriche ergeben sich bei Striche modulo 5
   if(rest==0)  rest=0xff;      //Keine Teilstriche am Ende der Anzeige
   else rest-=1; //Teilstriche, -1 wegen Beginn bei CG-RAM 0 => 1 Teilstrich

   full=full/5; //Anzahl voller Zeichen bei 5 Strichen pro Zeichen
  }


//Erstmal die voll ausgefllten Zeichen schreiben
 for(j=0; j<full; j++)
  {
#ifdef LCD1x16
   if(position==8) LCDPos(2,1);
   position++;
#endif
   LCDWriteByte(4);
  } 

 if(rest<0xFF)
  {
#ifdef LCD1x16
   if(position==8) LCDPos(2,1);
   position++;
#endif
   LCDWriteByte(rest); //Teilstriche am Ende der Anzeige
  }
  
 //Wenn keine Teilstriche und Anzeige nicht voll, ein Leerzeichen
 if(rest!=0xFF && full<LCDWIDTH)
  {
#ifdef LCD1x16
   if(position==8) LCDPos(2,1);
   position++;
#endif
   LCDWriteByte(0x20);
  }

 //Wenn die Anzeige nicht voll ist mit Leerzeichen fllen um Reste der alten
 //Anzeige zu lschen
 if(full<LCDWIDTH)
  {
   //Zustzlich 1 abziehen weil oben mglicherweise ein Leerzeichen
   //oder Teilstriche geschrieben wurde
   for(j=0; j<(LCDWIDTH-full-1); j++)
    {
#ifdef LCD1x16
     if(position==8) LCDPos(2,1);
     position++;
#endif
     LCDWriteByte(0x20);
    } 
  }                            

}
