//Datei: BarGraph.h
//Headerdatei fr BarGraph 
//
//Hardwaredefinitionen
// 
//PIC12C672 und 12F675
//
//Holger Klabunde
//01.01.2010
//Compiler CC5x

#ifndef BarGraph_H
#define BarGraph_H

//Makro's fr die Schieberegister
 		
#define CLK_ON() { GPIO.5=1; }
#define CLK_OFF() { GPIO.5=0; }
#define DATOUT_ON() { GPIO.2=1; }
#define DATOUT_OFF() { GPIO.2=0; }
#define STROUT_ON() { GPIO.4=1; }
#define STROUT_OFF() { GPIO.4=0; }

#define ALARM0	0x40	//Bit zum setzen der Alarmanzeige 1
#define ALARM1	0x80	//Bit zum setzen der Alarmanzeige 2

// !!! Der Prprozessor von CC5X ist zu bld zum scheien !!!!
// defines IMMER in Klammern setzen. Und fleissig casten.

//! Auskommentieren wenn es kein 1x16 Display ist !
//#define LCD1x16		//Spezialbehandlung fr 1x16 Displays

//Hier die Breite der LCD Anzeige ndern !
#define LCDWIDTH   ((unsigned char)16)         //Breite in Zeichen
#define LCDLINES   (((unsigned char)5) * LCDWIDTH) //z.B. 80 Striche bei 16 Zeichen

#define LCDMAX   ((unsigned char)240)
//Vollausschlag der Anzeige ist hier bei 240
//Kann auch auf kleinere Werte gendert werden
//Sollte aber beim teilen durch LCDLINES keinen Rest ergeben
//Hier wre auch noch 160 oder 80 mglich
#define LCDSCALE   (LCDMAX/(LCDLINES)) //Skalenfaktor der Anzeige

// Triggerlevel fr die LEDS
#define LED1MAX   ((unsigned char)240)
#define LED2MAX   ((unsigned char)240)

//Die Auflsung des AD-Wandlers ist 5V/256 = 19,5mV
//Vollausschlag bei
//LCDMAX=240 => 4,7V
//LCDMAX=160 => 3,1V
//LCDMAX= 80 => 1,5V

#endif
