// Datei: INITPIC.C
// BarGraph
// PIC Hardwaregrundeinstellungen
//
// Holger Klabunde 
// 30.04.2001
// Compiler CC5x

//Taktfrequenz des PIC => 4MHz
//Ein Taktzyklus=1us

#include "prozess.h"      /* Der verwendete Prozessor */

#include "bargraph.h" //Pindefinitionen
#include "lcd.h"
#include "protos.h"

//**************************************************
//**************************************************
//PIC Grundeinstellungen
//**************************************************
//**************************************************
void InitPIC()
{

 CLRWDT;		//Vor ndern des Prescalers auf Timer0 laut Microchip
 OPTION=0b10000110;	//Pullups off,Prescaler auf TMR0, 1:128
                        //Clk TMR0 intern
//Alle 256*1us*128 => alle 32ms Interrupt durch TMR0

//GP5	Ausgang CLK fr Schieberegister
//GP4	Ausgang STROBE fr Schieberegister
//GP3	Eingang noch frei
//GP2	Ausgang DATA fr Schieberegister
//GP1	Eingang AD-Wandler Kanal1
//GP0	Eingang AD-Wandler Kanal0
#ifdef PIC12C672
 TRIS = 0b11001011;  //Ein-Ausgnge festlegen 
 GPIO = 0x00;      //Port einmal initialisieren
 ADCON0 = 0b10000001; //AD-Modul an, FOSC32,Kanal0
 ADCON1 = 0b00000100; //GP0,1 Analoge Eingnge,Rest Digital, VREF=5V
#endif

#ifdef PIC12F675
 TRISIO = 0b11001011;  //Ein-Ausgnge festlegen 
 GPIO = 0x00;      //Port einmal initialisieren
 CMCON = 0x07;
 ANSEL = 0b00100011;    
 ADCON0 = 0b00000001; //AD-Modul an, Kanal0, left justified (ADRESH !)
#endif
                    
 lcdport=0;     //Reset serieller LCD-Port
 LCDCS_OFF(); 	//LCD-Anzeige deaktivieren

}
