// Datei: interupt.c
// BarGraph
// PIC Timer- und andere Interrupts
//
// Holger Klabunde
// 30.04.2001
// Compiler CC5x

#include "prozess.h"      /* Der verwendete Prozessor */

#include "bargraph.h" //Pindefinitionen
#include "protos.h"

#include <int16CXX.H>

#pragma origin 4

interrupt int_server( void)
{
 int_save_registers    // W, STATUS (and PCLATH)
// char sv_FSR = FSR;  // save FSR if required
                     //Neu in CC5x ! ging vorher automatisch

//******************************
//Beginn Externer Interrupt
//******************************
 if(INTF) //Externer Interrupt
  {
   INTF=0;  //Interruptflag lschen sonst
		           //Endlosinterrupt
  }
//******************************
//Ende Externer Interrupt
//******************************


//******************************
//Beginn Timerinterrupt
//******************************
 if(T0IF) //Timer0 Interrupt
  {
#ifdef PIC12C672
   ADCON0=0b10000001; //AD-Modul an, FOSC32,Kanal0

   while(TMR0<10);   //Warten bis Sample C sich geladen hat
   GO=1;      //AD-Wandlung starten
   while(GO); //Warten bis AD-Wandler fertig ist
   ad0=ADRES;        //AD-Wert speichern


   ADCON0=0b10001001; //AD-Modul an, FOSC32,Kanal1

   while(TMR0<20);    //Warten bis Sample C sich geladen hat
   GO=1;       //AD-Wandlung starten
   while(GO);  //Warten bis AD-Wandler fertig ist
   ad1=ADRES;         //AD-Wert speichern
#endif

#ifdef PIC12F675
   ADCON0=0b00000001; //AD-Modul an, FOSC32,Kanal0

   while(TMR0<10);   //Warten bis Sample C sich geladen hat
   GO=1;      //AD-Wandlung starten
   while(GO); //Warten bis AD-Wandler fertig ist
   ad0=ADRESH;        //AD-Wert speichern


   ADCON0=0b00000101; //AD-Modul an, FOSC32,Kanal1

   while(TMR0<20);    //Warten bis Sample C sich geladen hat
   GO=1;       //AD-Wandlung starten
   while(GO);  //Warten bis AD-Wandler fertig ist
   ad1=ADRESH;         //AD-Wert speichern
#endif

   refresh=0xFF;    //Anzeige auffrischen
    
   T0IF=0;  //Interruptflag lschen sonst
		           //Endlosinterrupt
  }
//******************************
//Ende Timerinterrupt
//******************************

//Alle wichtigen Register wiederherstellen
// FSR = sv_FSR;       // restore FSR if saved
                     //Neu in CC5x ! ging vorher automatisch
 int_restore_registers // W, STATUS (and PCLATH)
}
